################################################################################
####                    Copyright (C) 2017 Joseph McKeown                  #####
####                                                                       #####
#### This program is free software: you can redistribute it and/or modify  #####
#### it under the terms of the GNU General Public License as published by  #####
#### the Free Software Foundation, either version 3 of the License, or     #####
#### (at your option) any later version.                                   #####
####                                                                       #####
#### This program is distributed in the hope that it will be useful,       #####
#### but WITHOUT ANY WARRANTY; without even the implied warranty of        #####
#### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #####
#### GNU General Public License for more details.                          #####
####                                                                       #####
#### You should have received a copy of the GNU General Public License     #####
#### along with this program.  If not, see <http://www.gnu.org/licenses/>. #####
################################################################################

print "                   Copyright (C) 2017 Joseph McKeown               "
print ""
print "This program is free software: you can redistribute it and/or modify"
print "it under the terms of the GNU General Public License as published by"
print "the Free Software Foundation, either version 3 of the License, or"
print "(at your option) any later version."
print ""
print "This program is distributed in the hope that it will be useful,"
print "but WITHOUT ANY WARRANTY; without even the implied warranty of"
print "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the"
print "GNU General Public License for more details."
print ""
print "You should have received a copy of the GNU General Public License"
print "along with this program.  If not, see <http://www.gnu.org/licenses/>."
print ""
print "---------------------------------------------------------------------"
print ""
print "                   Please input your values below.                 "
print ""

################################################################################
################################################################################
#### This program takes four user inputs and takes 50 images through a     #####
####                    Raspberry Pi Camera Module.                        #####
####      The images are save in PNG format in a filepath as follows:      #####
####           /home/pi/Date--Organism--Dilution--Magnification            #####
####       Please run the program and follow the printed instructions.     #####
################################################################################
################################################################################

import time
import sys
import os
import picamera

#Ask for user inputs in order to name folder and files.
ValidInput = False
while ValidInput = False:
    Date = raw_input("Date: ")
    Organism = raw_input("Organism: ")
    Dilution = raw_input("Dilution (do not include \":\"): ")
    Magnification = raw_input("Magnification: ")
    if (":" not in Date) and (":" not in Organism) and (":" not in Dilution) and (":" not in Magnification):
        ValidInput = True
    else:
        print "Please do not include \":\" in any of your inputs."

#Create a new folder to store all the images.
if os.path.isdir("/home/pi/%s--%s--%s--%s"%(Date, Organism, Dilution, Magnification)) == False:
    os.mkdir("/home/pi/%s--%s--%s--%s"%(Date, Organism, Dilution, Magnification))

#Start the clock so that, if the Pi crashes while showing the camera preview,
# the program can be terminated at time = 2 minutes (see loop below).
time.clock()

#Set up camera as monochrome.
camera = picamera.PiCamera()
camera.color_effects = (128,128)

#Start the camera preview.
camera.start_preview()

#Take 51 images, image 0 will be black, due to the camera start up time.
for i in range(0,51):
    if time.clock() <= 120:
        camera.capture("/home/pi/%s--%s--%s--%s/"%(Date, Organism, Dilution, Magnification)+"%s--%s--%s--%s-im"%(Date, Organism, Dilution, Magnification)+str(i)+".png", format = 'png', resize = (512,512))
        time.sleep(1)
    else:
        camera.stop_preview()
        sys.exit()

#Remove image 0.
os.remove("/home/pi/%s--%s--%s--%s/"%(Date, Organism, Dilution, Magnification)+"%s--%s--%s--%s-im0"%(Date, Organism, Dilution, Magnification)+".png")

#End the preview.
camera.stop_preview()
        
